/**
 * Binary Search Tree with keys of type E (which are Comparable).
 */
public class BinarySearchTree<E extends Comparable<E>> {

  /**
   * Internal class to represent a node in a binary search tree.
   */
  class Node {
    public E key;
    public Node left;
    public Node right;

    /**
     * Constructs a BST node, saving the @param key.
     */
    public Node(E key) {
      this.key = key;
    }
  }

  // root of the tree
  private Node root;

  /**
   * Constructs an empty binary tree.
   */
  public BinarySearchTree() {
    root = null;
  }

  /**
   * Determines if this BST contains a particular key.
   * 
   * @param key - key to look for.
   * @return true/false if one of the nodes in this tree has this key.
   */
  public boolean contains(E key) {
    // TODO
    return false;
  }

  /**
   * Adds a key to the BST if not already at a node in the tree.
   * 
   * @param key - key to save at a newly created node.
   */
  public void add(E key) {
    // TODO
  }

  /**
   * Removes a key from the BST (if it exists).
   * 
   * @param key - key to remove from the tree.
   */
  public void remove(E key) {
    // TODO
  }

  /**
   * Finds the minimum node in a tree rooted at a particular node.
   * 
   * @param node - root of the (sub)tree to find the minimum of.
   * @return node with the minimum key.
   */
  public Node getMinNode(Node node) {
    while (node.left != null) {
      node = node.left;
    }
    return node;
  }

  /**
   * @return a String representation of the tree.
   */
  public String toString() {
    return toString("", root);
  }

  /**
   * Returns a string representation of the subtree.
   * 
   * @param padding - spacing and vertical bars to print before the node.
   * @param node    - the root of the subtree to print.
   * @return appended line to print for this node (and child nodes).
   */
  private String toString(String padding, Node node) {
    if (node == null) {
      return "";
    }

    String result = padding + "└──(" + node.key.toString() + ")" + "\n";

    padding += "│    ";
    result += toString(padding, node.left);
    result += toString(padding, node.right);

    return result;
  }

  /**
   * Test some BST methods.
   * 
   * @param args
   */
  public static void main(String[] args) {
    BinarySearchTree<Integer> bst = new BinarySearchTree<>();

    bst.add(12);
    bst.add(8);
    bst.add(14);
    bst.add(5);
    bst.add(9);
    bst.add(20);
    bst.add(17);

    System.out.println(bst);
  }
}